#!/usr/bin/env python
# -*- coding: utf-8 -*-
import sys
#from ase import Atoms
from gpaw import GPAW
import numpy as np
#sys.path.append('../')
from ase.autoneb import AutoNEB

from ase.calculators.emt import EMT
import ase.parallel as mpi

size = mpi.world.size
rank = mpi.world.rank

#def nice_attach_calculators(images, groups):
#    

class EMT2(EMT):
    def __init__(self, i):
        EMT.__init__(self)
        self.i = i
    def get_potential_energy(self, atoms):
        print('GPE r%s i%s' % (rank, self.i))
        return EMT.get_potential_energy(self, atoms)

def attach_calculators(images):
    nim = len(images)
    n = size // nim      # number of cpu's per image
    j = rank // n  # my image number
    assert nim * n == size

    for i in range(nim):
        ranks = np.arange(i * n, (i + 1) * n)
        if rank in ranks:
            images[i].set_calculator(EMT())
        #images[i].set_calculator(EMT())


autoneb=AutoNEB(attach_calculators,
                prefix='neb',
                n_simul=3,
                n_max=7,
                fmax=0.05,
                k=0.5,
                parallel=True,
                maxsteps=[50, 1000])
autoneb.run()
